// -*- mode: c++ -*- 
/*  ndb-connectors: Wrappers for the NDBAPI
    Copyright (C) 2006 MySQL, Inc.
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or 
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/**
 *   State of all nodes in the cluster; returned from 
 *   ndb_mgm_get_status()
 */

%rename ndb_mgm_cluster_state ClusterState; 

struct ndb_mgm_cluster_state {
private: 
  ndb_mgm_cluster_state();
  ~ndb_mgm_cluster_state();
  /** Number of entries in the node_states array */
  int no_of_nodes;
  /** An array with node_states*/
  %immutable;
  struct ndb_mgm_node_state node_states[];
  %mutable;
};


%extend ndb_mgm_cluster_state { 

public:
  int getNoOfNodes() { 
    return self->no_of_nodes;
  }

//TODO - FIX THIS
  ndb_mgm_node_state* getNodeStates() { 
    return self->node_states;
  }

};
    
