// -*- mode: c++ -*- 
/*  ndb-connectors: Wrappers for the NDBAPI
    Copyright (C) 2006 MySQL, Inc.
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or 
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

%include "globals.i"
%include "config.h"

%{
#include <my_global.h>
#include <my_sys.h>

#include <mysql.h>
#include <NdbApi.hpp> 

#undef PACKAGE
#undef PACKAGE_NAME
#undef PACKAGE_STRING
#undef PACKAGE_TARNAME
#undef PACKAGE_VERSION
#undef VERSION

#include "config.h"

//#include <m_ctype.h>


  long long getMicroTime() 
  {
    struct timeval tTime;
    gettimeofday(&tTime, 0);
    long long microSeconds = (long long) tTime.tv_sec * 1000000 + tTime.tv_usec;
    return microSeconds;
  }



typedef int voidint; 
typedef Uint32 NdbTimestamp;

typedef NdbDictionary::Object NdbDictObject;
typedef NdbDictionary::Table NdbDictTable;
typedef NdbDictionary::Column NdbDictColumn;
typedef NdbDictionary::Index NdbDictIndex;
typedef NdbDictionary::Dictionary NdbDictDictionary;
typedef NdbDictionary::Event NdbDictEvent;
typedef struct st_byte { 
  char * theString; 
  int theLength; 
} BYTES; 
%}

long long getMicroTime();
/*
typedef char my_bool;
enum enum_mysql_timestamp_type
{
  MYSQL_TIMESTAMP_NONE= -2, MYSQL_TIMESTAMP_ERROR= -1,
  MYSQL_TIMESTAMP_DATE= 0, MYSQL_TIMESTAMP_DATETIME= 1, MYSQL_TIMESTAMP_TIME= 2
};

typedef struct st_mysql_time
{
  unsigned int  year, month, day, hour, minute, second;
  unsigned long second_part;
  my_bool       neg;
  enum enum_mysql_timestamp_type time_type;
} MYSQL_TIME;
*/
// TODO: This is a little stupid. 
//   Why don't we just typedef these right in the first place
%rename(NdbObject) NdbDictObject;
%rename(NdbTable) NdbDictTable;
%rename(NdbColumn) NdbDictColumn;
%rename(NdbIndex) NdbDictIndex;
%rename(NdbDictionary) NdbDictDictionary;
%rename(NdbEvent) NdbDictEvent;


enum AbortOption {
  CommitIfFailFree = 0,         
  TryCommit = 0,
  AbortOnError = 0,
  CommitAsMuchAsPossible = 2,
  AO_IgnoreError = 2
};

enum ExecType { 
  NoExecTypeDef = -1,
  Prepare = 0,
  NoCommit = 1,
  Commit = 2,
  Rollback = 3
};

typedef void (* NdbAsynchCallback)(int, NdbTransaction*, void*);
typedef void (* NdbEventCallback)(NdbEventOperation*, Ndb*, void*);

typedef const char * NdbDatetime;
typedef const char * NdbDate;
typedef const char * NdbTime; 
typedef Uint32 NdbTimestamp;


