/**
 * 
 */
package com.mysql.cluster.ndbj;

/**
 * The NDB/J unchecked exception hierarchy is used to manifest user-program
 * errors, that the program is not expected to be able recover from.  
 * <br> An example of such an unchecked exception is when a user enters an 
 * invalid name for a column.
 * 
 * @author jdowling
 */
public class NdbApiRuntimeException extends RuntimeException {

	protected static final long serialVersionUID = 1L;
	/**
	 * 
	 */
	public NdbApiRuntimeException() {
	}

	/**
	 * @param arg0
	 */
	public NdbApiRuntimeException(String arg0) {
		super(arg0);
	}

	/**
	 * @param arg0
	 */
	public NdbApiRuntimeException(Throwable arg0) {
		super(arg0);
	}

	/**
	 * @param arg0
	 * @param arg1
	 */
	public NdbApiRuntimeException(String arg0, Throwable arg1) {
		super(arg0, arg1);
	}
    
    public NdbApiRuntimeException(NdbApiException ex) {
        super(ex.getMessage(), ex);
    }

}
