package com.mysql.cluster.ndbj;


/**
 * This exception is thrown if there is a temporary problem in the
 * NDB cluster. Often, this problem will resolve itself
 * if you wait for the resource to become available.
 * For example, if a node fails in the cluster, any transactions that were
 * active on that node at the time of failure will fail by throwing
 * a NdbClusterConnectionTemporaryException. If the application retries
 * the transaction (it will be started on a different node), it is likely
 * that the transaction will succeed (assuming the new node managing the
 * transaction does not fail).
 *
 * <br>Sample code:<br>
 * <code>
 *<br>
 *<br>
 *<br>
 *<br>
 *<br>
 *<br>
 *<br>
 *<br>
 * </code>
*/
public class NdbClusterConnectionTemporaryException extends NdbApiException {

	protected static final long serialVersionUID = 1L;

	/**
	 *
	 * @param error
	 */
	public NdbClusterConnectionTemporaryException(long error) {
		super(error);
	}

	/**
	 *
	 * @param message
	 */
	public NdbClusterConnectionTemporaryException(String message) {
		super(message);
	}

}
