// -*- mode: c++ -*- 
/*  ndb-connectors: Wrappers for the NDBAPI
    Copyright (C) 2006 MySQL, Inc.
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or 
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


%module(directors="1") mgmj

/*
%typemap(javaimports) NdbMgmFactory, ndb_mgm_handle, ndb_mgm_cluster_state, ndb_mgm_node_state "import com.mysql.cluster.errors.*;"
%pragma(java) moduleimports="import com.mysql.cluster.errors.*;"
%pragma(java) jniclassimports="import com.mysql.cluster.errors.*;"
*/

%{

#define NDB_exception(excp, msg) { ndb_throw_exception(jenv, #excp, msg);  } 

void ndb_throw_exception(JNIEnv *jenv, const char * excp, const char *msg) { 
  const char * prefix = "com/mysql/cluster/mgmj/";
  char * exception = (char *)malloc(strlen(excp)+strlen(prefix)+1);
  strcpy(exception,prefix);
  strcat(exception,excp);

  //jclass clazz = jenv->FindClass("java/lang/RuntimeException");
  jclass clazz = jenv->FindClass(exception);
  jenv->ThrowNew(clazz,msg);
}
%}

%typemap(out) (BaseEventWrapper *) {
  $result=$1->theEvent; 
 } 
//%typemap(jtype) (BaseEventWrapper *) "BaseEvent";
%typemap(jstype) (BaseEventWrapper *) "NdbLogEvent";
%typemap(jni) (BaseEventWrapper *) "ndb_logevent *";

%typemap(javaout) (BaseEventWrapper *) { 
  long cPtr = $jnicall; 
  return (cPtr == 0) ? null :  new NdbLogEvent(cPtr,true);
 }
/*
%rename NdbMgmLogEventManager NdbMgmLogEventManagerRef;
%rename NdbMgmReply NdbMgmReplyRef;
%rename NdbLogEvent        NdbLogEventRef;
%rename NodeState NodeStateRef;
%rename NdbLogeventType  NdbLogeventTypeRef;
%rename NdbMgmFactory       NdbMgmFactoryRef;
%rename NdbMgm              NdbMgmRef;
*/

%include "mgmapi/mgmglobals.i"
%include "mgmapi/NdbLogEvent.i"
%include "mgmapi/NdbLogEventManager.i"
%include "mgmapi/NdbMgm.i"
%typemap(javacode) NdbMgmFactory %{ 

  static {
    try {
      System.loadLibrary("mgmj");
    } catch (UnsatisfiedLinkError e) {
      System.err.println("Native code library failed to load. \n" + e);
      System.exit(1);
    }
    mgmj.ndb_init();
  }

 %}
%include "mgmapi/NdbMgmFactory.i"
%include "mgmapi/ClusterState.i"
%include "mgmapi/NodeState.i"
%include "mgmapi/NdbMgmReply.i"
