package testsuite.ndbj;

import testsuite.BaseNdbjTestCase;
import com.mysql.cluster.ndbj.AbortOption;
import com.mysql.cluster.ndbj.ExecType;

import com.mysql.cluster.ndbj.NdbApiException;
import com.mysql.cluster.ndbj.NdbOperation; 
import com.mysql.cluster.ndbj.NdbTransaction; 
import com.mysql.cluster.ndbj.NdbResultSet; 
import java.sql.SQLException;

import java.io.BufferedReader;
import java.io.InputStreamReader;

public class BasicTest extends BaseNdbjTestCase {

	public BasicTest(String arg0) {
		super(arg0);
	}
	
	public void setUp() throws Exception { 
		super.setUp();

		System.out.println("Creating table");
		this.createTable("basic_test", "(id int, name varchar(32), age int, primary key(id)) engine=ndbcluster");
		
	}

	public void testSingleInsertString() throws NdbApiException,SQLException { 
	
		trans = ndb.startTransaction();
		NdbOperation op = trans.getNdbOperation("basic_test");
		op.insertTuple();
		op.equal("id", 1);
		op.setString("name", "Monty");
		trans.execute(ExecType.Commit,AbortOption.AbortOnError,true);
		
		String nameVal = (String)this.getSingleValue("basic_test", "name", "where id=1");
		assertEquals("Monty",nameVal);
	}
	
	public void testSingleInsertInt() throws NdbApiException,SQLException { 
		
		trans = ndb.startTransaction();
		NdbOperation op = trans.getNdbOperation("basic_test");
		op.insertTuple();
		op.equal("id", 1);
		op.setInt("age", 100);
		trans.execute(ExecType.Commit,AbortOption.AbortOnError,false);
		
		int nameVal = (Integer)this.getSingleValue("basic_test", "age", "where id=1");		
		assertEquals(nameVal,100);
	}
}
