package testsuite.ndbj;

import testsuite.BaseNdbjTestCase;

import com.mysql.cluster.ndbj.NdbApiException;
import com.mysql.cluster.ndbj.NdbOperation;
import com.mysql.cluster.ndbj.NdbTransaction;
import com.mysql.cluster.ndbj.NdbIndexScanOperation;
import com.mysql.cluster.ndbj.NdbResultSet; 
import com.mysql.cluster.ndbj.AbortOption;
import com.mysql.cluster.ndbj.ExecType;


public class OrderedIndexScanTest extends BaseNdbjTestCase {

	protected String col1="id";
	protected String col2="name";
	protected String theTableName="t_oi_scan";
	protected static final int SELECT_COUNT=12000;

	public static void main(String[] args) {
		junit.textui.TestRunner.run(OrderedIndexScanTest.class);
	}

	public OrderedIndexScanTest(String arg0) {
		super(arg0);
	}

	public void setUp() throws Exception {
		super.setUp();
		this.createTable(theTableName,
				"(`"+col1+"` INT, `"+col2+"` int, primary key (`"+col1+"`,`"+col2+"`)) ENGINE=ndbcluster;");
		this.stmt.executeUpdate("insert into " + theTableName + " values (1,1)");
		this.stmt.executeUpdate("insert into " + theTableName + " values (1,2)");
		this.stmt.executeUpdate("insert into " + theTableName + " values (1,3)");
		this.stmt.executeUpdate("insert into " + theTableName + " values (1,4)");
		this.stmt.executeUpdate("insert into " + theTableName + " values (1,5)");
	}

	public void tearDown() throws Exception {
		//super.tearDown();
	}

	public void testOIScan() {
		

		try {
			
			trans = ndb.startTransaction();
			
			NdbIndexScanOperation iop=
				trans.getNdbIndexScanOperation("PRIMARY", theTableName);
			
			// We'll use this once we've implemented it
			iop.readTuples(NdbOperation.LockMode.LM_CommittedRead, 0,0,false,false,false /*readRangeNo set to true to be able to read "many" ranges in one scan op*/);


			/*   System.out.println("foo");
			*/  
			iop.equal(0,1);
			
			
			assertEquals(NdbIndexScanOperation.BoundType.BoundEQ.type,4);
			/*
			iop.setBoundInt(col1, 
					NdbIndexScanOperation.BoundType.BoundEQ,
					1);
			*/
			long bound_no=0;
			iop.endOfBound(bound_no);


			iop.getValue(col1);
			iop.getValue(col2);

			NdbResultSet rs = iop.resultData();
			trans.execute(ExecType.NoCommit, 
					AbortOption.AbortOnError, 
					true);



			int count=1;
			while(rs.next())
			{
				int col1Val = rs.getInt(col1);
				int col2Val = rs.getInt(col2);
				assertEquals(col1Val,1);
				assertEquals(col2Val,count);
				
				count++;
			}


			assertTrue(true);

	
		}
		catch (NdbApiException e) {
			System.out.println("Caught NdbApiException:\t" + e.getMessage() + e.getCode());
			assertTrue(false);
		}
		finally {
			if (trans!=null)
				trans.close(); 
		}

	}

}
