#!/usr/bin/env python
##  ndb-connectors: Wrappers for the NDBAPI
##    Copyright (C) 2006 MySQL, Inc.
##    
##    This program is free software; you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation; either version 2 of the License, or 
##    (at your option) any later version.
##    
##    This program is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with this program; if not, write to the Free Software
##    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


# bootstrap setuptools if necessary
from ez_setup import use_setuptools
use_setuptools()

from distutils.command.clean import clean
from setuptools import setup,Extension
import os.path
import sys

description = """Python wrapper of the NDBAPI"""

classifiers="""\
Development Status :: 2 - Pre-Alpha
License :: OSI Approved :: GPL
Operating System :: POSIX :: Linux
Programming Language :: C++
Programming Language :: Python
Topic :: Software Development :: Libraries :: Python Modules
"""

version = "0.5.0"

setup(name="python-ndbapi",
      version=version,
      description=description, 
      long_description=description,
      author="Monty Taylor",
      author_email="mtaylor@mysql.com",
      url="http://launchpad.net/ndb-connectors",
      platforms="linux",
      license="GPL",
      classifiers=filter(None, classifiers.splitlines()),

      ext_modules=[
                    Extension("mysql.cluster._mgmapi",
                              sources=["mgmapi.cpp"],
                              # FIXME - need to get just the MGMAPI ones
                              depends=["../swig/%s" % f for f in os.listdir("../swig")],
                              language="c++",
                             
                              ),
                    Extension("mysql.cluster._ndbapi",
                              sources=["ndbapi.cpp"],
                              depends=["../swig/%s" % f for f in os.listdir("../swig")],
                              language="c++",
                             
                              )

                    ],
      test_suite = "mysql.cluster.tests.NdbTest.test_all",
      entry_points = {
        'sqlalchemy.databases': [ 'ndbapi = mysql.cluster.alchemy:dialect' ]
      },
      py_modules=["mysql.cluster.ndbapi","mysql.cluster.mgmapi","mysql.cluster.alchemy"]
      
     )

